#!/usr/sbin/dtrace -s
/*
 * sunblade100.d - Turn the console keyboard into a noisy typewriter.
 *                 Written in DTrace (Solaris 10 3/05).
 *
 * This version is for SunBlade 100s. See the DTrace typewriter collection
 * for other varients.
 *
 * 15-Sep-2005, ver 0.71                (first release!)
 *
 * USAGE:       sunblade100.d &
 *
 * SEE ALSO:    /usr/dt/bin/sdtaudiocontrol     # to set volume
 *
 * Standard Disclaimer: This is freeware, use at your own risk.
 *
 * 15-Sep-2005  Brendan Gregg   Created this.
 */

#pragma D option quiet
#pragma D option destructive
#pragma D option switchrate=20hz

inline int ENTERKEY = 40;               /* SunBlade 100 */
inline int COLUMNWARN = 72;             /* warning ping */

dtrace:::BEGIN
{
	trace("typewriter.d running for the console keyboard.\n");
	column = 0;
}

fbt:kbtrans:kbtrans_untrans_keypressed_raw:entry
/arg1 != ENTERKEY/
{
	system("cat click.au > /dev/audio &");
	column++;
}

fbt:kbtrans:kbtrans_untrans_keypressed_raw:entry
/arg1 != ENTERKEY && column == COLUMNWARN/
{
	system("cat clink.au > /dev/audio &");
}

fbt:kbtrans:kbtrans_untrans_keypressed_raw:entry
/arg1 == ENTERKEY/
{
	system("cat return.au > /dev/audio &");
	column = 0;
}

