#!/usr/sbin/dtrace -s
/*
 * ultra5.d - Turn the console keyboard into a noisy typewriter.
 *            Written in DTrace (Solaris 10 3/05).
 *
 * This version is for Ultra 5/10s. See the DTrace typewriter collection
 * for other varients.
 *
 * 08-Sep-2005, ver 0.70		(first release!)
 *
 * USAGE:       ultra5.d &
 *
 * SEE ALSO:	/usr/dt/bin/sdtaudiocontrol	# to set volume
 *
 * Standard Disclaimer: This is freeware, use at your own risk.
 *
 * 08-Sep-2005  Brendan Gregg   Created this.
 */

#pragma D option quiet
#pragma D option destructive
#pragma D option switchrate=20hz

inline int ENTERKEY = 89;		/* Ultra 5/10 */
inline int COLUMNWARN = 72;		/* warning ping */

dtrace:::BEGIN
{
	trace("typewriter.d running for the console keyboard.\n");
	column = 0;
}

fbt:kb:kbdkeyreleased:entry
/arg1 != ENTERKEY/
{
	system("cat click.au > /dev/audio &");
	column++;
}

fbt:kb:kbdkeyreleased:entry
/arg1 != ENTERKEY && column == COLUMNWARN/
{
	system("cat clink.au > /dev/audio &");
}

fbt:kb:kbdkeyreleased:entry
/arg1 == ENTERKEY/
{
	system("cat return.au > /dev/audio &");
	column = 0;
}
